local *

{
  :LibStub
  :idTweaks
  :idTweaksUtils
  :idTweaksOptions
} = _G
{ :Option, :ToggleOption } = idTweaksOptions
{ :split, :join } = idTweaksUtils.string

AceConfig = LibStub "AceConfig-3.0"
AceConfigDialog = LibStub "AceConfigDialog-3.0"

class Module
  new: (addon, name, ...) =>
    -- print "Module#new:#{name}"

    @addon = addon
    @name = name

    @ace_module = @addon.ace_addon\NewModule name, ...

    @ace_module.OnInitialize = ->
      -- print "Module#new:#{name}:ace_module.OnInitialize"

      @set_database!
      @set_options!
      @initialize!

    @ace_module.OnEnable = ->
      -- print "Module#new:#{name}:ace_module.OnEnable"

      @check!

    @ace_module.OnDisable = ->
      -- print "Module#new:#{name}:ace_module.OnDisable"

      @disable!

  set_database: =>
    -- print "Module#set_database:#{@name}"

    @addon.db.profile[@name] = @addon.db.profile[@name] or {}
    @db = @addon.db.profile[@name]

  set_options: =>
    -- print "Module#set_options:#{@name}"

    @options = Option @, @name, @name, @name, {},
      enabled: ToggleOption @, "enabled", "Enabled", "Enables / Disables the Module"

    @addon.options\add_option @options

  initialize: =>
    -- print "Module#initialize:#{@name}"

  check: =>
    -- print "Module#check:#{@name}"

    enabled_option = @options\get_option "enabled"
    is_enabled = enabled_option\get!

    if is_enabled
      @enable!
      @positioning!
    else
      @disable!

  enable: =>
    -- print "Module#enable:#{@name}"

  positioning: =>
    -- print "Module#positioning:#{@name}"

  disable: =>
    -- print "Module#disable:#{@name}"

_G.idTweaksModule = Module


-- ace_addon = AceAddon\NewAddon "idTweaks", "AceConsole-3.0"
-- ace_db = AceDB\New "idTweaksDB", nil, "Default"

-- class Module1
--   new: (root = false) =>
--     @name = "idTweaks"
--     @modules = {}
--     @root = root
--     @parent = nil
--     @ace_addon = ace_addon
--     @ace_db = ace_db
--     @db = nil
--     @options = nil

--     if root
--       @ace_addon = AceAddon\NewAddon @name, "AceConsole-3.0"
--       @ace_db = AceDB\New "#{@name}DB", nil, "Default"

--       @ace_addon.OnInitialize = ->
--         @initialize!

--       @ace_addon.OnEnable = ->
--         @enable!

--       @ace_addon.OnDisable = ->
--         @disable!

--   set_database: () =>
--     if @parent
--       @parent.db.modules or= {}
--       @parent.db.modules[@name] = {}
--       @db = @parent.db.modules[@name]
--     else
--       @ace_db.profile[@name] or= {}
--       @db = @ace_db.profile[@name]

--   add_module: (module) =>
--     @modules[module.name] = module
--     module.parent = @
  
--   initialize: () =>
--     for module in @modules
--       module\initialize!

--   enable: () =>
--     for module in @modules
--       module\initialize!

--   disable: () =>
--     for module in @modules
--       module\initialize!

-- class Automation extends Module1
--   new: () =>
--     super!
--     @name = "Automation"

--   initialize: () =>
--     @ace_addon\RegisterEvent "foo", ->
--       @db.foo = "DERP"

--     super!

-- root = Module1 true
-- root.add_module Automation!
